/****************************************************************************************
   Temperatur Logger - Software for logging temperature data with the DS18B20 and ESP32
   Written by Sebastian Hinz, https://www.diy-temperature-logger.com
   Licensed under GPLv3. See LICENSE for details.
****************************************************************************************/
#ifndef _MYNTPCLIENT_H_
#define _MYNTPCLIENT_H_

#include <NTPClient.h>

//////////////////////////////////////////////////////////////////////
class MyNTPClient
{
public:
  MyNTPClient();
  static MyNTPClient& GetInstance();
 
public:
  void update();
  unsigned long getEpochTime() { return (m_ntpClient==0) ? 0 : m_ntpClient->getEpochTime(); }
  String getFormattedTime() { return (m_ntpClient==0) ? "" : m_ntpClient->getFormattedTime(); }
  bool isTimeSynchronized() { return m_bValidTime; }
  
private:
  void setup();
  bool summertime_EU(int year, byte month, byte day, byte hour, byte tzHours);

private:
  String m_timeServer;
  int m_timeZoneOffset;
  int m_timeSummerWinter;
  NTPClient *m_ntpClient;
  bool m_bValidTime;
};

//////////////////////////////////////////////////////////////////////
// Code by JeeLabs http://news.jeelabs.org/code/
// Released to the public domain! Enjoy!
///////////////////////////////////////////////////////////////////////////////

#define SECONDS_FROM_1970_TO_2000 946684800

// Simple general-purpose date/time class (no TZ / DST / leap second handling!)
class DateTime {
public:
    DateTime (uint32_t t =0);
    uint16_t year() const       { return 2000 + yOff; }
    uint8_t month() const       { return m; }
    uint8_t day() const         { return d; }
    uint8_t hour() const        { return hh; }
    uint8_t minute() const      { return mm; }
    uint8_t second() const      { return ss; }

protected:
    uint8_t yOff, m, d, hh, mm, ss;
};

#endif
